# This file is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as 
# published by the Free Software Foundation here:
# (http://www.gnu.org/licenses/gpl-2.0.html)
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

DEPENDS = dash,glibc,m4
ARCH = x86_64
URL = http://www.gnu.org/software/bison/
REPO = dev
BRIEF = GNU Project parser generator (yacc replacement)
DESC = Bison is a general-purpose parser generator that converts an \
annotated context-free grammar into a deterministic LR or generalized \
LR (GLR) parser employing LALR(1) parser tables.
SLVER = 1

ARCHIVE := $(PWD)/SRC/$(shell ls SRC|egrep '(bz2|gz|tar|xz)$$'|tail -1)
TYPE := $(shell file -ib $(ARCHIVE)|cut -d';' -f1|tr -d '\n')
SRCDIR := $(shell tar -tf $(ARCHIVE)|head -1|sed 's/\/.*//')
PATCHDIR := $(PWD)/SRC/patches
VERSION := $(shell echo $(SRCDIR)|egrep -o '\-[0-9].*'|sed 's/^-//')-$(SLVER)

include /usr/share/sl/Makefile.snaplinux

$(SRCDIR): $(ARCHIVE)
	@if [ '$(TYPE)' == 'application/x-bzip2' ]; then \
		tar -jxf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-gzip' ]; then \
		tar -zxf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-tar' ]; then \
		tar -xf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-xz' ]; then \
		tar -xf $(ARCHIVE); \
	else \
		echo 'Unable to determine archive type'; \
		exit 1; \
	fi

$(SRCDIR)/config.log: $(SRCDIR)
	@cd $(SRCDIR) && for patch in `find $(PATCHDIR) -name \*.patch`; do \
		patch --verbose -Np0 -i $$patch; \
	done
	@cd $(SRCDIR); \
	./configure \
		--prefix=/usr \
		--build=x86_64-snap-linux-gnu \
		--host=x86_64-snap-linux-gnu \
		--target=x86_64-snap-linux-gnu

$(SRCDIR)/src/bison: $(SRCDIR)/config.log
	@cd $(SRCDIR) && make

$(ROOT): $(SRCDIR)/src/bison
	@if [ -d $(ROOT) ]; then \
		touch $(ROOT); \
	else \
		mkdir -v $(ROOT); \
	fi

	@cd $(SRCDIR) && make install DESTDIR=$(ROOT)

test: $(ROOT)
	@cd $(SRCDIR); \
	make check

clean:
	@rm -rvf $(ROOT) \
		$(SLINFO) \
		$(MANIFEST) \
		$(FILES) \
		$(SRCDIR)

